package log

import "testing"

func TestDev(t *testing.T) {
	PROD = false
	// log.system = "dev"
	Error("d", "sdf", "sdfsdf")
	ErrorF(H{"Test": "set"}, "d", "sdf", "sdfsdf")
	Debug("d", "sdf", "sdfsdf")
	DebugF(H{"Test": "set"}, "d", "sdf", "sdfsdf")
	Warn("d", "sdf", "sdfsdf")
	WarnF(H{"Test": "set"}, "d", "sdf", "sdfsdf")
	Info("d", "sdf", "sdfsdf")
	InfoF(H{"Test": "set"}, "d", "sdf", "sdfsdf")
}

func TestProd(t *testing.T) {
	PROD = true
	// log.system = "prod"
	Error("d", "sdf", "sdfsdf")
	ErrorF(H{"Test": "set"}, "d", "sdf", "sdfsdf")
	Debug("d", "sdf", "sdfsdf")
	DebugF(H{"Test": "set"}, "d", "sdf", "sdfsdf")
	Warn("d", "sdf", "sdfsdf")
	WarnF(H{"Test": "set"}, "d", "sdf", "sdfsdf")
	Info("d", "sdf", "sdfsdf")
	InfoF(H{"Test": "set"}, "d", "sdf", "sdfsdf")
}

func TestSubDev(t *testing.T) {
	PROD = false
	l := Sub("TestSubDev")
	l.Error("d", "sdf", "sdfsdf")
	l.ErrorF(H{"Test": "set"}, "d", "sdf", "sdfsdf")
	l.Debug("d", "sdf", "sdfsdf")
	l.DebugF(H{"Test": "set"}, "d", "sdf", "sdfsdf")
	l.Warn("d", "sdf", "sdfsdf")
	l.WarnF(H{"Test": "set"}, "d", "sdf", "sdfsdf")
	l.Info("d", "sdf", "sdfsdf")
	l.InfoF(H{"Test": "set"}, "d", "sdf", "sdfsdf")
}

func TestSubProd(t *testing.T) {
	PROD = true
	l := Sub("TestSubProd")
	l.Error("d", "sdf", "sdfsdf")
	l.ErrorF(H{"Test": "set"}, "d", "sdf", "sdfsdf")
	l.Debug("d", "sdf", "sdfsdf")
	l.DebugF(H{"Test": "set"}, "d", "sdf", "sdfsdf")
	l.Warn("d", "sdf", "sdfsdf")
	l.WarnF(H{"Test": "set"}, "d", "sdf", "sdfsdf")
	l.Info("d", "sdf", "sdfsdf")
	l.InfoF(H{"Test": "set"}, "d", "sdf", "sdfsdf")
}

func TestCustTmpl(t *testing.T) {
	PROD = true
	l := Sub("TestCustTmpl")
	CustFormater := NewLogFormater()
	CustFormater.InfoTmplStr = `{{Time}} [{{blue}}INFO {{reset}}]` +
		`{{if .System}}({{cyan}}{{.System}}{{reset}}){{end}} ` +
		`key: test, value:{{.Fields.Test}}{{"\n"}}`
	l.SetTmpl(CustFormater)
	l.Error("d", "sdf", "sdfsdf")
	l.ErrorF(H{"Test": "set"}, "d", "sdf", "sdfsdf")
	l.Debug("d", "sdf", "sdfsdf")
	l.DebugF(H{"Test": "set"}, "d", "sdf", "sdfsdf")
	l.Warn("d", "sdf", "sdfsdf")
	l.WarnF(H{"Test": "set"}, "d", "sdf", "sdfsdf")
	l.Info("d", "sdf", "sdfsdf")
	l.InfoF(H{"Test": "set"}, "d", "sdf", "sdfsdf")
}
